Assignee: Eric Davis % Done: 0%
Resolution: Fixed Affected version:  

Description

When using the stylesheet_link_tag helper (and probably others) with :plugin to build URLs for plugin assets, this helper doesn't take

into account the relative_url_root set through Redmine::Utils::relative_url_root

I think I've traced the problem to the method plugin_asset_path in module Engines::RailsExtensions::AssetHelpers, file

vendor/plugins/engines/asset_helpers.rb

I guess that strictly speaking Engines is responsible for the bug and not Redmine.  I'll leave it up to someone else to decide whether

or not to resolve it in Redmine.

Related issues:

Has duplicate Redmine - Defect #5021: stylesheet_link_tag does not honor Redm... Closed 2010-03-09

Has duplicate Redmine - Defect #3753: Plugin asset URLs not correctly generat... Closed 2009-08-18

Associated revisions

Revision 4094 - 2010-09-17 06:06 - Eric Davis

Use the relative_url_root when generating asset_paths. #3935

Contributed by Daniel S from Redmine.

History

#1 - 2010-05-05 13:58 - Jérémie Delaitre

This duplicates #5021

#2 - 2010-08-02 17:41 - Daniel S

--- vendor/plugins/engines/lib/engines/rails_extensions/asset_helpers.rb~    2010-08-02 17:40:47.000000000 +02

00

+++ vendor/plugins/engines/lib/engines/rails_extensions/asset_helpers.rb    2010-08-02 17:40:47.000000000 +020

0

@@ -109,7 +109,7 @@ module Engines::RailsExtensions::AssetHe

   # Returns the publicly-addressable relative URI for the given asset, type and plugin

   def self.plugin_asset_path(plugin_name, type, asset)

     raise "No plugin called '#{plugin_name}' - please use the full name of a loaded plugin." if Engines.plugi

ns[plugin_name].nil?

-    "/#{Engines.plugins[plugin_name].public_asset_directory}/#{type}/#{asset}" 

+    "#{ActionController::Base.relative_url_root}/#{Engines.plugins[plugin_name].public_asset_directory}/#{typ

e}/#{asset}" 

   end

 end

#3 - 2010-08-21 19:40 - Nick Bolton

As a workaround, I used the following (more verbose) code (for example, in a hook):

class EventNotificationOverrideViewer < Redmine::Hook::ViewListener

  def view_layouts_base_html_head(context = { })

    javascript_include_tag "#{ActionController::Base.relative_url_root}/#{Engines.plugins['my_plugin'].public_

asset_directory}/javascripts/somejs" 

  end

end
#4 - 2010-09-08 09:45 - Go MAEDA

Daniel S's patch works fine with Redmine 1.0.1 (deployed in a subdirectory) and Projects Tree View plugin (

http://github.com/MischaTheEvil/projects_tree_view).

I wish this issue would be fixed in 1.0.2.

#5 - 2010-09-13 20:13 - Jérémie Delaitre

I just tried Daniel S's patch on a bitnami stack (redmine 1.0.1) and the redmine_time_tracker plugin (http://github.com/delaitre/redmine_time_tracker

(master branch)) and it works fine too.

#6 - 2010-09-17 06:04 - Eric Davis

- Status changed from New to Resolved

- Target version set to 1.0.2

- Resolution set to Fixed

I have a fork of Engines now where I've added this fix to the plugin and also another fix that was floating around on Redmine. Fixed in r4094 for

Redmine.

#7 - 2010-09-20 05:51 - Eric Davis

- Status changed from Resolved to Closed

Merged into 1.0-stable for release in 1.0.2
